const
N_MAX = 500;


var
   f	: text;
   no	: byte;
   code	: word;

procedure topdown(n : longint; initial : word; perv_size : word; p : real);
(* This is basically a random test generated topdown but
 * it also contain a long ``perverse'' chain, i.e. a subgraph
 * where a base monster has a child with his child and so on.
 * This gives VERY long numbers.
 * p is the number of queries (percentage of all the possible queries) *)

var
   parent     : array[1..N_MAX,1..2] of word;
   coding     : array[1..N_MAX] of word; { this is use to renumber the monsters }

   procedure make_coding(n : word);
   var
      used    : array[0..N_MAX-1] of boolean;
      i, j, k : word;
      counter : word;
   begin
      for i := 0 to n-1 do used[i] := false;
      i := random(n); 
      coding[n] := i+1;
      counter := n-1;
      used[i] := true;
      while counter > 0 do
      begin
	 j := random(counter)+1;
	 for k := 1 to j do
	    repeat i := (i+1) mod n until not used[i];
	 coding[counter] := i+1;
	 used[i] := true;
	 dec(counter);
      end;
   end;

var
   p1, p2 : word;
   i, j	  : word;
   m	  : longint;
begin
   make_coding(n);
   writeln(f,n,' ',n-initial);

   for i := 1 to initial do parent[i,1] := 0;      

   for i := initial+1 to n do
   begin
      if i <= initial+perv_size then
      begin
	 p1 := initial-1;
	 p2 := i-1
      end
      else
      begin
	 p1 := random(i-1)+1;
	 repeat p2 := random(i-1)+1 until p1 <> p2
      end;
      parent[i,1] := p1;
      parent[i,2] := p2;
   end;

   for i := 1 to n do
      if parent[i,1] <> 0 then
	 writeln(f,coding[i],' ',coding[parent[i,1]],' ',coding[parent[i,2]]);
   
   m := trunc(n*n*(p/100));
   writeln(f,m);
   for i := 1 to n do
      for j := 1 to n do
	 if random(100) < p then
	 begin
	    writeln(f,coding[i],' ',coding[j]);
	    dec(m);
	    if m = 0 then exit;
	 end;
   while (m <> 0) do
   begin
      i := random(n)+1;
      repeat j := random(n)+1 until i <> j;
      writeln(f,coding[i],' ',coding[j]);
      dec(m)
   end;
end;

procedure generate(no : byte);
var s_no : string;
begin
   str(no, s_no);
   assign(f,'a'+s_no+'.in');
   rewrite(f);
   randseed := 666+no;
   case no of
     3	: topdown(20, 4,  0,  2.5);
     4	: topdown(100,10, 2,  0.2);
     5	: topdown(300,2, 10, 40.0);
     6	: topdown(300,3, 20, 35.0);
     7	: topdown(300,5, 50, 18.0);
     8	: topdown(300,6, 100, 12.0);
     9	: topdown(300,7, 150, 4.0);
     10	: topdown(300,8, 200, 3.0);
     11	: topdown(300,9, 250, 2.0);
     12	: topdown(300,11, 280, 1.0);
   end;			     
   close(f);
end;

begin
   if paramcount < 1 then
     for no:=3 to 12 do
       generate(no)
   else begin
     val(paramstr(1), no, code);
     generate(no)
   end
end.
